# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

"""A LetterTokenizer is a tokenizer that divides text at non-letters.  That's
  to say, it defines tokens as maximal strings of adjacent letters, as defined
  by string.ascii_letters+'0123456789'.

  Note: this does a decent job for most European languages, but does a terrible
  job for some Asian languages, where words are not separated by spaces.
  """

from chartokenizer import CharTokenizer


class LetterTokenizer(CharTokenizer):

    def __init__(self, input):
        CharTokenizer.__init__(self, input)

    def isTokenChar(self, c):
        return (c.isalpha() or c.isdigit())
        
