# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

import segmenttermpositions

class SegmentMergeInfo(object):
    __slots__ = ['base', 'docMap', 'postings', 'reader', 'term', 'termEnum']

    def __init__(self, b, te, r):
        self.base = b
        self.reader = r
        self.termEnum = te
        self.term = te.term
        self.docMap = None
        self.postings = segmenttermpositions.SegmentTermPositions(r)

        if self.reader.deletedDocs is not None:
            # build array with maps document numbers around deletions
            deletedDocs = self.reader.deletedDocs
            maxDoc = self.reader.maxDoc()
            self.docMap = [0] * maxDoc
            j = 0
            for i in range(maxDoc):
                if deletedDocs.get(i):
                    self.docMap[i] = -1
                else:
                    self.docMap[i] += 1
            

    def close(self):
        self.termEnum.close()
        self.postings.close()


    def next(self):
        if self.termEnum.next():
            ### hmmm?
            self.term = self.termEnum.term
            return True
        else:
            self.term = None
            return False

    def __repr__(self):
        return '<SegMergInfo' + str(self.term) +'>'
