# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

from lupy.util.priorityqueue import PriorityQueue

class SegmentMergeQueue(PriorityQueue):
    
    def __init__(self, size):
        PriorityQueue.__init__(self, size)


    def lessThan(self, a, b):
        comp = cmp(a.term, b.term)
        if comp is 0:
            return a.base < b.base
        else:
            return comp < 0


    def close(self):
        while self.top() is not None:
            self.pop().close()
