# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

from segmenttermdocs import SegmentTermDocs
import copy

class SegmentTermPositions(SegmentTermDocs):
    __slots__ = ['position', 'proxCount', 'proxStream']


    def __init__(self, p):
        self.proxCount = 0
        self.position = 0
        SegmentTermDocs.__init__(self, p)

        self.proxStream = self.parent.proxStream.clone()


    def close(self):
        SegmentTermDocs.close(self)
        self.proxStream.close()


    def next(self):
        for i in range(self.proxCount):
            # skip unread positions
            self.proxStream.readVInt()

        # run super
        if SegmentTermDocs.next(self):
            # Note frequency
            self.proxCount = self.frq
            # Reset position
            self.position = 0
            return True

        return False


    def nextPosition(self):
        self.proxCount -= 1
        self.position += self.proxStream.readVInt()
        return self.position


    def read(self, docs, freqs):
        raise Exception, 'why?'
    

    def seekTi(self, ti):
        SegmentTermDocs.seekTi(self, ti)

        if ti is not None:
            self.proxStream.seek(ti.proxPointer)
        else:
            self.proxCount = 0


    def skippingDoc(self):
        # skip all positions
        for f in range(self.frq, 0, -1):
            self.proxStream.readVInt()
            
            
    def __repr__(self):
        s = '<stp>' + str(self.position)
        return s
    


