# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

class TermEnum(object):
    '''Abstract class for enumerating terms.

    Term enumerations are always order by Term.compareTo(). Each term in
    the enumeration is greater tha all that precede it.'''
    

    def next(self):
        # Increments the enumerations to the next element. True if one exists
        pass

    def term(self):
        # Returns the current Term in the enumeration
        pass

    def docFreq(self):
        # Returns the docFreq of the current Term in the enumeration
        pass

    def close(self):
        # Closes the enumeration to further activity, freeing resources
        pass
