# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

import sys

class PhrasePositions(object):
    __slots__ = ['count', 'doc', 'nxt', 'offset', 'position', 'tp']
    
    
    def __init__(self, t, o):
        self.tp = t
        self.offset = o
        
        self.position = 0
        self.count = 0
        self.doc = 0
        
        self.next()
        
        
    def firstPosition(self):
        self.count = self.tp.freq()
        self.nextPosition()
        
        
    def next(self):
        """Increments to next doc"""
        
        if not self.tp.next():
            # close stream
            self.tp.close()
            # sentinel value
            self.doc = sys.maxint
            return
        self.doc = self.tp.doc()
        self.position = 0
        
        
    def nextPosition(self):
        if self.count > 0:
            self.count -= 1
            # read subsequent positions
            self.position = self.tp.nextPosition() - self.offset
            return True
        else:
            self.count -= 1
            return False
        
        
        
    def __repr__(self):
        res = '<pp>d:' + str(self.doc) + ' p:' + str(self.position) + ' o:' + str(self.offset)
        return res
