__doc__= """ Stores info on path to pdftotedxt exe
>>> d=Share()
>>> k=Share()
>>> d.po=2312312
>>> k.po
2312312
>>> if sys.platform=="linux2":
...     a=oK.pdfToTextFilePath=='pdftotext'
... else:
...     a=oK.pdfToTextFilePath==os.path.join(oK.moduleDir, "pdftotext.exe")
... 
>>> a
1
>>> 
"""
import os
import sharedGlobals
import sys
import pickle
import traceback

def verifyOrMakeDir(dirPath):
    if not os.path.isdir(dirPath):
        os.mkdir(dirPath)




class MissingPdfToTextError(Exception):
    pass
class SearchRootInexistent(Exception):
    pass


class Share(dict):
    __state={}
    def __init__(self):
        self.__dict__=Share.__state
        self.moduleDir=os.path.abspath(os.path.dirname(sharedGlobals.__file__))
        self.configPath=os.path.join(self.moduleDir,".pdfConfig")
        self.workingDir=os.path.abspath(os.getcwd())
    
    def __repr__(self):
        for key,value in self.__dict__.items():
            print "%s: %s" %(key,value)
        print "-------DICT----------"
        for key,value in self.items():
            print "%s: %s" %(key,value)
        return " "

    def getRootPath(self):
        self._load()
        if self.has_key("searchRootPath") and os.path.isdir(self["searchRootPath"]):
            return self["searchRootPath"]
        else:
            return False

    def setRootPath(self,searchRootPath):
        if os.path.isdir(searchRootPath):
            self["searchRootPath"]=searchRootPath
            self._save()
            return True
        else:
            return False

    def setFailures(self,searchRootPath,failures=[]):
        assert os.path.isdir(searchRootPath), "%s is not an existing path" %searchRootPath
        for fileName in failures:
            assert os.path.isfile(fileName), "%s is not an existing file" %searchRootPath
        self[searchRootPath]=failures
        self._save()
        
    def _save(self):
	file_handle=open(self.configPath,'w')
        pickle.dump(self,file_handle)
        file_handle.close()
    
    def _load(self):
        if os.path.isfile(self.configPath):
            try:
                fh=open(self.configPath,'r')
                obj=pickle.load(fh)
                #self.__dict__=obj.__dict__
                for key,value in obj.items():
                    self[key]=value
            except:
                traceback.print_exc()
                if os.name=="posix":
                    fh.close()
                    os.system(" dos2unix " + self.configPath)
                    fh=open(self.configPath,'r')
                    self.__dict__=pickle.load(fh).__dict__
                    


oK=Share()
oK.testDir=os.path.join(oK.moduleDir,"testDir")

if sys.platform=="win32" or sys.platform=="cygwin":
    oK.pdfToTextFilePath=os.path.join(oK.moduleDir, "pdftotext.exe")
    if not os.path.isfile(oK.pdfToTextFilePath):
        if os.system("pdftotext"): # ON Search Path, returns 1 if callable
            oK.pdfToTextFilePath="pdftotext"
            os.system("cls")
        else:
            raise MissingPdfToTextError
else:
    oK.pdfToTextFilePath="pdftotext"
    if not os.system("pdftotext"):
        raise MissingPdfToTextError


oK.indexDirName="indexDir"
oK.nonParsableDir="nonParsableDir"
#oK.configName=".pdfSearch"

    
def _test():
    import doctest, sharedGlobals
    return doctest.testmod(sharedGlobals)

if __name__ =="__main__":
    _test()
