# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

"""
Test cases for lupy directory classes.
"""

import sys
import unittest
import lupy.analysis.lowercasetokenizer
import cStringIO as StringIO


class AnalysisTestCase(unittest.TestCase):

    def testTokenizer(self):
        r = StringIO.StringIO('there WAS a quick Brown FOX')
        a = lupy.analysis.lowercasetokenizer.LowerCaseTokenizer(r)
        self.failUnlessEqual(a.next().termText(),'there')
        self.failUnlessEqual(a.next().termText(),'was')
        self.failUnlessEqual(a.next().termText(),'a')




if __name__ == "__main__":
    unittest.main()
