# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

"""
Test cases for lupy directory classes.
"""

import sys
import unittest
import lupy.store.ramdirectory as ramdirectory
import lupy.store.fsdirectory as fsdirectory

import lupy.document.document as document
import lupy.document.field as field
import StringIO


class DocumentTestCase(unittest.TestCase):
    
    def testDocument(self):
        d = document.Document()
        f1 = field.Field('text','quick brown fox', store=True, index=True, token=True)
        d.add(f1)
        f2 = field.Field('fname','file1', store=True, index=True, token=False)
        d.add(f2)

        self.assertEquals(d.getField("fname"), f2)
        self.assertEquals(d.get("text"), 'quick brown fox')
        self.assertEquals(d.get("nosuch"), None)
        self.assertEquals(d.getField("nosuch"), None)
        self.assertEquals(d.fields(), [f1, f2])


testCases = [DocumentTestCase]

if __name__ == "__main__":
    unittest.main()
