# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

"""
Test cases for lupy directory classes.
"""

import sys, os, time
import unittest
import cStringIO as StringIO

import lupy.store.ramdirectory as ramdirectory
import lupy.store.fsdirectory as fsdirectory

import lupy.index.indexwriter as indexwriter	
import lupy.index.indexreader as indexreader
import lupy.index.term as term

import lupy.document.document as document
import lupy.document.field as field

import lupy.analysis.simpleanalyzer

import cStringIO as StringIO


#class IndexWriterTestCase(unittest.TestCase):
class IndexWriterTestCase(object):

    def testTerm(self):
        t = term.Term('atext', 'that')
        tt = term.Term('btext', 'those')
        ttt = term.Term('atext', 'that')
        self.failUnlessEqual(t > tt, False)

        l=[tt,t,tt]
        l.sort()
        self.failUnlessEqual(l, [t,tt,tt])

        d = {}
        d[t]=1
        self.failUnlessEqual(1, d[ttt])
        
        t = term.Term('this', 'apple')
        tt = term.Term('this', 'orange')
        self.failUnlessEqual(t > tt, False)
        
        
    def getDoc(self):
        d = document.Document()
        f = field.Field.Text('path','file')
        d.add(f)
        
        f = field.Field.Keyword('modified','monday')
        d.add(f)
        
        return d
        
        
    def testIndexWriter(self):
        #text1 = open('/Python22/README.txt').read()
        
        t = time.time()
        a = lupy.analysis.simpleanalyzer.SimpleAnalyzer()
        iw = indexwriter.IndexWriter(os.path.normpath('/cygwin/home/amir/test/_testIW'), a, True)

        d = self.getDoc()
        f = field.Field.Text('text',StringIO.StringIO('the quick brown fox jumps over the lazy dog'))
        d.add(f)
        iw.addDocument(d)
        
        #d = self.getDoc()
        #f = field.Field.Text('text',open('/usr/dict/words.txt'))
        #d.add(f)
        #iw.addDocument(d)
        
        iw.optimize()
        iw.close()
        print 'elapsed: ', time.time() - t
        

    def testIndexReader(self):
        return
        ir = indexreader.IndexReader('/cygwin/home/amir/test/_testIW')
        self.failUnlessEqual(1,1)
        ir.close()

        
testCases = [IndexWriterTestCase]

if __name__ == "__main__":
    #unittest.main()
    IndexWriterTestCase().testIndexWriter()
