# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.

"""
Test cases for lupy directory classes.
"""


import sys
import unittest
import lupy.store.ramdirectory as ramdirectory
import lupy.store.fsdirectory as fsdirectory
import lupy.util.priorityqueue
import lupy.util.bitvector


class UtilTestCase(unittest.TestCase):
    
    text1 = """The quick brown fox wasn't quick enough and got eaten by the hounds."""
    text2 = """The hounds of doom are quick and prowl the nine circles of hell."""

    longtext = text1 * 100

    
    def testPriorityQueue(self):
        import random
        size = 10
        pq = lupy.util.priorityqueue.IntegerQueue(size)
        sum = sum2 = 0

        for i in range(size):
            pq.put(random.randint(0,100))

        for i in range(size):
            next=pq.pop()
            last=next
            sum2 += last
        

    def testBitVector(self):
            
        bv = lupy.util.bitvector.BitVector(19)
        set = [0,3,6,18]
        for s in set:
            bv.set(s)

        for s in set:
            self.failUnlessEqual(bv.get(s), 1)        

        
testCases = [UtilTestCase]

if __name__ == "__main__":
    unittest.main()
